<template>
  <select v-model="selectedItem">
    <option v-for="item in flattenedItems" :key="item.key" :value="item.key">
      {{ item.text }}
    </option>
  </select>
</template>

<script setup lang="ts">
import type { MenuData } from '@/model/menu'

const props = defineProps<{
  modelValue: String
  menuItems: MenuData[]
}>()

const emit = defineEmits(['update:modelValue'])
const selectedItem = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  }
})

const flattenedItems = ref<MenuData[]>([])

onMounted(() => {
  flattenItems(props.menuItems)
})

function flattenItems(items: MenuData[], prefix: string = ''): void {
  items.forEach((item) => {
    const prefixedName = prefix ? `${prefix} > ${item.text}` : item.text
    flattenedItems.value.push({ ...item, text: prefixedName })
    if (item.children) {
      flattenItems(item.children, prefixedName)
    }
  })
}
</script>
